clear;          //lösche alle Variablen
xdel(winsid()); //schliesse alle Grafiken

v=343;          //Schallgeschwindigkeit 343m/s
g=9.81;         //Erdbeschleunigung in m/s²
t=0:0.1:5;      //Zeit bis zum Hoeren des Auftreffens in s (von 0s in 0.1s-Schritten bis 5s)

//Koeffizienten der Quadratischen Gleichung
//0 = a*s² + b*s + c  mit s für die Brunnentiefe 
a=1/v^2;
b=-(2*t)/v - 2/g;
c=t^2;

D=b^2 - 4*a*c;  //Diskriminante D>0 -> 2 reelle Lösungen, (nur zur Kontrolle)
                //              D=0 -> 1 reelle Lösung,
                //              D<0 -> keine reelle, nur imaginäre Lösungen

s1=(-b+sqrt(b^2 - 4*a*c))/(2*a);    //erste Lösung der Quadratischen Gleichung
s2=(-b-sqrt(b^2 - 4*a*c))/(2*a);    //zweite Lösung der Quadratischen Gleichung

plot2d(t,s2,2); xgrid;              //drucke Bild des Ergebnis'
xtitle('Brunnentiefe','Zeit bis zum Hoeren des Auftreffens [s]','Brunnentiefe [m]')


//Ansatz zur Implementierung der Formel im Mikrocontroller
const1=2/v;
const2=2/g;
const3=4/v^2;
const4=v^2/2;
temp1 = t*const1 + const2;          //Zwischenergebnis1 mit gemessener Zeit t
temp2 = t^2 * const3;               //Zwischenergebnis2 mit gemessener Zeit t
s3=(temp1 - sqrt( temp1^2 - temp2)) * const4;   //finale Rechnung zur Ermittlung der Hoehe

//Ausdruck zur Kontrolle über erstes Ergebnis oben in rot
//plot2d(t,s3,5);

